IRremoteESP8266

Public Member Functions | Static Public Member Functions | Private Member Functions | Static Private Member Functions | Private Attributes | List of all members
IRTrumaAc Class Reference

Class for handling detailed Truma A/C messages. More...

`#include <ir_Truma.h>`

Collaboration diagram for IRTrumaAc:
[legend]

## Public Member Functions
| IRTrumaAc (const uint16_t pin, const bool inverted=false, const bool use_modulation=true)
| Class constructor. More...
void | send (const uint16_t repeat=kNoRepeat)
| Send the current internal state as an IR message. More...
int8_t | calibrate (void)
| Run the calibration to calculate uSec timing offsets for this platform. More...
void | begin (void)
| Set up hardware to be able to send a message. More...
void | stateReset (void)
| Reset the state of the remote to a known good state/sequence. More...
void | on (void)
| Set the requested power state of the A/C to on. More...
void | off (void)
| Set the requested power state of the A/C to off. More...
void | setPower (const bool on)
| Change the power setting. More...
bool | getPower (void) const
| Get the value of the current power setting. More...
void | setTemp (const uint8_t celsius)
| Set the temperature. More...
uint8_t | getTemp (void) const
| Get the current temperature setting. More...
void | setFan (const uint8_t speed)
| Set the speed of the fan. More...
uint8_t | getFan (void) const
| Get the current fan speed setting. More...
uint8_t | getMode (void) const
| Get the operating mode setting of the A/C. More...
void | setMode (const uint8_t mode)
| Set the operating mode of the A/C. More...
void | setQuiet (const bool on)
| Change the Quiet setting. More...
bool | getQuiet (void) const
| Get the value of the current quiet setting. More...
uint64_t | getRaw (void)
| Get a copy of the internal state/code for this protocol. More...
void | setRaw (const uint64_t state)
| Set the internal state from a valid code for this protocol. More...
stdAc::state_t | toCommon (void) const
| Convert the current internal state into its stdAc::state_t equivalent. More...
String | toString (void) const
| Convert the current internal state into a human readable string. More...

## Static Public Member Functions
static bool | validChecksum (const uint64_t state)
| Verify the checksum is valid for a given state. More...
static uint8_t | convertMode (const stdAc::opmode_t mode)
| Convert a stdAc::opmode_t enum into its native mode. More...
static uint8_t | convertFan (const stdAc::fanspeed_t speed)
| Convert a stdAc::fanspeed_t enum into it's native speed. More...
static stdAc::opmode_t | toCommonMode (const uint8_t mode)
| Convert a native mode into its stdAc equivalent. More...
static stdAc::fanspeed_t | toCommonFanSpeed (const uint8_t speed)
| Convert a native fan speed into its stdAc equivalent. More...

## Private Member Functions
void | checksum (void)
| Calculate & set the checksum for the current internal state of the remote. More...

## Static Private Member Functions
static uint8_t | calcChecksum (const uint64_t state)
| Calculate the checksum for a given state. More...

## Private Attributes
IRsend | _irsend
| Instance of the IR send class. More...
TrumaProtocol | _
uint8_t | _lastfan
uint8_t | _lastmode

## Detailed Description

Class for handling detailed Truma A/C messages.

## Constructor & Destructor Documentation

## ◆ IRTrumaAc()

IRTrumaAc::IRTrumaAc | ( | const uint16_t | pin,
|  | const bool | inverted = `false`,
|  | const bool | use_modulation = `true`
| ) |  |
| explicit

Class constructor.

Parameters

  [in] | pin | GPIO to be used when sending.
  [in] | inverted | Is the output signal to be inverted?
  [in] | use_modulation | Is frequency modulation to be used?

## Member Function Documentation

## ◆ begin()

void IRTrumaAc::begin | ( | void |  | ) |

Set up hardware to be able to send a message.

## ◆ calcChecksum()

uint8_t IRTrumaAc::calcChecksum | ( | const uint64_t | state | ) |
| staticprivate

Calculate the checksum for a given state.

Parameters

  [in] | state | The value to calc the checksum of.

Returns
  The calculated checksum value.

## ◆ calibrate()

int8_t IRTrumaAc::calibrate | ( | void |  | ) |
| inline

Run the calibration to calculate uSec timing offsets for this platform.

Returns
  The uSec timing offset needed per modulation of the IR Led.

Note
  This will produce a 65ms IR signal pulse at 38kHz. Only ever needs to be run once per object instantiation, if at all.

## ◆ checksum()

void IRTrumaAc::checksum | ( | void |  | ) |
| private

Calculate & set the checksum for the current internal state of the remote.

## ◆ convertFan()

uint8_t IRTrumaAc::convertFan | ( | const stdAc::fanspeed_t | speed | ) |
| static

Convert a stdAc::fanspeed_t enum into it's native speed.

Parameters

  [in] | speed | The enum to be converted.

Returns
  The native equivalent of the enum.

## ◆ convertMode()

uint8_t IRTrumaAc::convertMode | ( | const stdAc::opmode_t | mode | ) |
| static

Convert a stdAc::opmode_t enum into its native mode.

Parameters

  [in] | mode | The enum to be converted.

Returns
  The native equivalent of the enum.

## ◆ getFan()

uint8_t IRTrumaAc::getFan | ( | void |  | ) | const

Get the current fan speed setting.

Returns
  The current fan speed/mode.

## ◆ getMode()

uint8_t IRTrumaAc::getMode | ( | void |  | ) | const

Get the operating mode setting of the A/C.

Returns
  The current operating mode setting.

## ◆ getPower()

bool IRTrumaAc::getPower | ( | void |  | ) | const

Get the value of the current power setting.

Returns
  true, the setting is on. false, the setting is off.

## ◆ getQuiet()

bool IRTrumaAc::getQuiet | ( | void |  | ) | const

Get the value of the current quiet setting.

Returns
  true, the setting is on. false, the setting is off.

## ◆ getRaw()

uint64_t IRTrumaAc::getRaw | ( | void |  | ) |

Get a copy of the internal state/code for this protocol.

Returns
  The code for this protocol based on the current internal state.

## ◆ getTemp()

uint8_t IRTrumaAc::getTemp | ( | void |  | ) | const

Get the current temperature setting.

Returns
  The current setting for temp. in degrees celsius.

## ◆ off()

void IRTrumaAc::off | ( | void |  | ) |

Set the requested power state of the A/C to off.

## ◆ on()

void IRTrumaAc::on | ( | void |  | ) |

Set the requested power state of the A/C to on.

## ◆ send()

void IRTrumaAc::send | ( | const uint16_t | repeat = `kNoRepeat` | ) |

Send the current internal state as an IR message.

Parameters

  [in] | repeat | Nr. of times the message will be repeated.

## ◆ setFan()

void IRTrumaAc::setFan | ( | const uint8_t | speed | ) |

Set the speed of the fan.

Parameters

  [in] | speed | The desired setting.

## ◆ setMode()

void IRTrumaAc::setMode | ( | const uint8_t | mode | ) |

Set the operating mode of the A/C.

Parameters

  [in] | mode | The desired operating mode.

## ◆ setPower()

void IRTrumaAc::setPower | ( | const bool | on | ) |

Change the power setting.

Parameters

  [in] | on | true, the setting is on. false, the setting is off.

## ◆ setQuiet()

void IRTrumaAc::setQuiet | ( | const bool | on | ) |

Change the Quiet setting.

Parameters

  [in] | on | true, the setting is on. false, the setting is off.

Note
  Quiet is only available in Cool mode.

## ◆ setRaw()

void IRTrumaAc::setRaw | ( | const uint64_t | state | ) |

Set the internal state from a valid code for this protocol.

Parameters

  [in] | state | A valid code for this protocol.

## ◆ setTemp()

void IRTrumaAc::setTemp | ( | const uint8_t | celsius | ) |

Set the temperature.

Parameters

  [in] | celsius | The temperature in degrees celsius.

## ◆ stateReset()

void IRTrumaAc::stateReset | ( | void |  | ) |

Reset the state of the remote to a known good state/sequence.

## ◆ toCommon()

stdAc::state_t IRTrumaAc::toCommon | ( | void |  | ) | const

Convert the current internal state into its stdAc::state_t equivalent.

Returns
  The stdAc equivalent of the native settings.

## ◆ toCommonFanSpeed()

stdAc::fanspeed_t IRTrumaAc::toCommonFanSpeed | ( | const uint8_t | spd | ) |
| static

Convert a native fan speed into its stdAc equivalent.

Parameters

  [in] | spd | The native setting to be converted.

Returns
  The stdAc equivalent of the native setting.

## ◆ toCommonMode()

stdAc::opmode_t IRTrumaAc::toCommonMode | ( | const uint8_t | mode | ) |
| static

Convert a native mode into its stdAc equivalent.

Parameters

  [in] | mode | The native setting to be converted.

Returns
  The stdAc equivalent of the native setting.

## ◆ toString()

String IRTrumaAc::toString | ( | void |  | ) | const

Convert the current internal state into a human readable string.

Returns
  A human readable string.

## ◆ validChecksum()

bool IRTrumaAc::validChecksum | ( | const uint64_t | state | ) |
| static

Verify the checksum is valid for a given state.

Parameters

  [in] | state | The value to verify the checksum of.

Returns
  true, if the state has a valid checksum. Otherwise, false.

## Member Data Documentation

## ◆ _

TrumaProtocol IRTrumaAc::_
| private

## ◆ _irsend

IRsend IRTrumaAc::_irsend
| private

Instance of the IR send class.

## ◆ _lastfan

uint8_t IRTrumaAc::_lastfan
| private

## ◆ _lastmode

uint8_t IRTrumaAc::_lastmode
| private

The documentation for this class was generated from the following files:

- src/ir_Truma.h
- src/ir_Truma.cpp